#import "ButtonBox.h"

@implementation ButtonBox

+(id) new
{
  [self alloc];
  [self init];
  return self;
}

-(id) init
{
  //  [self setOrientationHorizontal: self];
  box = [GSHbox new];  
  return self;
}

-(id) initWithButtonArray: (NSArray *) theButtons
{
  [self init];
  [self setButtonArray: theButtons];
  return self;
}

-(void) _setButtonTargets
{
  [buttonArray makeObjectsPerform: @selector(setTarget:) withObject: self];
  [buttonArray makeObjectsPerform: @selector(setAction:) withObject: @selector(_buttonPressed:)];
}

-(void) _buttonPressed: (id) sender
{
  [[self target] performSelector: [self action] withObject: sender];
}

-(void) _buttonsIntoBox
{
  int i;
  for(i=[buttonArray count]-1;i>0;i--)
    {
      [box addView: [buttonArray objectAtIndex: i]];
    }
}

-(void) _makeButtons
{
  NSButton *button;
  int i;
  
  for(i=[buttonTitlesArray count]-1;i>0;i--)
    {
      button = [NSButton new];
      [button setTitle: [buttonTitlesArray objectAtIndex: i]];
      [buttonArray addObject: button];
    }
}

-(void) _commonBoxSetup
{
}

-(void) dealloc
{
  RELEASE(box);
  RELEASE(buttonArray);
  RELEASE(buttonTitlesArray);
  [super dealloc];
}

- (void) setOrientationHorizontal: (id) sender
{
  box = [GSHbox new];
  [self _commonBoxSetup];
  [self _buttonsIntoBox];
}

- (void) setOrientationVertical: (id) sender
{
  box = [GSVbox new];
  [self _commonBoxSetup];
  [self _buttonsIntoBox];
}

- (void) setButtonArray: (NSArray *) theButtons
{
  RELEASE(buttonArray);
  buttonTitlesArray = [NSMutableArray new];
  [buttonTitlesArray setArray: theButtons];
  [self _makeButtons];
  [self _setButtonTargets];
}

- (NSArray*) buttonArray
{
  return buttonTitlesArray;
}


-(void) setAction: (SEL) aSelector
{
  _action = aSelector;
}
-(SEL) action
{
  return _action;
}

-(void) setTarget: (id) aTarget
{
  _target = aTarget;
}
-(id) target
{
  return _target;
}

-(void) forwardInvocation:(NSInvocation *)anInvocation
{
  NSLog(@"Invocation forwarded!\n");
  [anInvocation invokeWithTarget: box];
}

-(BOOL) respondsToSelector: (SEL) aSelector
{
  if([box respondsToSelector: aSelector])
    {
      NSLog(@"Box responds to selector!\n");
      return YES;
    }
  return NO;
}

@end
